//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used 
//for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
//For all report layout operations 
//client creates the object of this class.
//The methods of this class are stateless 
//and takes all required information such 
//as requestor User Info etc. in each call.
using Category = com.intellica.client.reportutils.Category;
//This class represents the Report Category.

//This class creates a new category and adds it to the Intellicus Repository.
public partial class CategoryManager
{
    public static void CreateNewCategory()
	{
        
        try
        {
            // Static Init call. it will read the properties for report server related attributes 
            // like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
            //in the INTERA_HOME property of the ReportClient.properties file.
            //with the absolute path of ReportClient.properties.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
            ReportClient.init(is_Renamed);

            // Prepare a requestor user info bean object.
            // This user should be present in Intellicus application.
            //Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
            System.String userId = "Admin";
            System.String password = "Admin";
            System.String organization = "Intellica";
            UserInfo requestorUserInfo = new UserInfo(userId, password, organization);

            // Create a Layout Manager class object 
            // for report layout management related operations			
            LayoutManager lm = new LayoutManager();

            System.String catName = "ChildCategory";
            Category newCategory = new Category(catName);
            newCategory.IsPublic = true;
            newCategory.IsHidden = false;
            newCategory.Description = "This is the new category just created";
            //Set the parent category Id inside which, the new Category is to be added.
            //If not set, then the new Category is added at Root folder.
            newCategory.ParentCategoryId = "571937DE-9934-90CB-FFD0-371470A44B7E";
            //To set the category id manually, otherwise, it takes system generated Category Id.
            newCategory.CategoryId = "ChildCategory";
            newCategory.MenuName = catName;

            //Adds new category to the Intellicus repository.
            //Syntax: public Category addCategory(Category category,UserInfo userInfo)
            lm.addCategory(newCategory, requestorUserInfo);
        }
        catch (LayoutHandlerException lhe)
        {
            Logger.error(lhe);
        }
        catch (System.Exception e)
        {
            Logger.error(e);
        }
	}
}