//This API is used to delete an Existing Category from the Intellicus repository along with the Reports present in that Category.
//User need to provide the Category ID of the Category which is to be deleted.
//This would require user to provide UserInfo to authorize for Reports related Activites.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used
//for all Layout use cases.This 
//class has many constructors with
//the option of log and no log exceptions. 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
//For all report layout operations 
//client creates the object of this class.
//The methods of this class are stateless 
//and takes all required information such 
//as requestor User Info etc. in each call.

/// <summary> 
/// This class is used for deleting an existing category from the report layout repository. 
/// </summary>
public partial class CategoryManager
{
	public static void  DeleteCategory()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			//Category ID of the Category that is to be deleted.
            System.String categoryID = "690BB258-14D1-CE6D-4FB1-4963EAE4B530";
			
			//Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			
			//This method is used to delete the existing category from the report 
			//engine's report layout repository along with the reports contained in it. 
			
			//@param 1 : Category ID of the Existing Category that is to be deleted.
			//@param 2 : UnConditional - If true than deletes the category even there are any report layouts present in the category along with allits reports.
			//@param 3 : userInfo - UserInfo object authorization.
			lm.deleteCategory(categoryID, true, requestorUserInfo);
		}
		catch (LayoutHandlerException lhe)
		{
            Logger.error(lhe);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}