/*
* This program 
*Send request to intellicus engine to create a Database connection.
*it will create a Database connection with specified name
*/
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using DBConnection = com.intellica.client.common.DBConnection;
//This class stores the information regarding a database connection.
using DBDriver = com.intellica.client.common.DBDriver;
//For creating DBDriver object
using UserInfo = com.intellica.client.common.UserInfo;
//For getting user information
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used 
//for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using com.impetus.interaj.globals;
using LayoutManager = com.intellica.client.layout.LayoutManager;
//For all report layout operations 
//client creates the object of this class.
//The methods of this class are stateless 
//and takes all required information such 
//as requestor User Info etc. in each call.

/// <summary>
/// This class is used to create a Database Connection in the Intellicus Repository
/// </summary>
public partial class DBConnectionMgr
{
    public static void CreateDBConnection()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			//Making an object of DBDriver 
			DBDriver driverDB = new DBDriver();
			//Making an object of hashmap for DBDriver
			System.Collections.Hashtable hMap = new System.Collections.Hashtable();
			//setting DB driver URL for making a connection
			driverDB.Url = "jdbc:sqlserver://192.168.33.52:1433;databaseName=M90;selectMethod=cursor;user=sa;password=intellicus";
			//Set Databse Provider for Micorsoft SQL Server pass MSSQL
			driverDB.Provider = "MSSQL";
			//Setting DataBase properties in hashmap
			//Set server IP
			hMap["SERVER"] = "192.168.33.52";
			//Set  server port
			hMap["PORT"] = "1433";
			//Set Database name
			hMap["DATABASE"] = "M90";
			//set driver version
			hMap["DRIVERVERSION"] = "2005";
			//setting hashmap in attribute hashmap
			driverDB.AttrHash = hMap;
			//Making an object of DBConnection 
			DBConnection dbConn = new DBConnection();
			//setting DBDriver in DBConnection object 
			dbConn.DbDriver = driverDB;
			//setting user name of DB connection
			dbConn.UserId = "sa";
			//setting password of DB connection
			dbConn.Password = "intellicus";
			//setting connection name that is going to established
			dbConn.ConnectionName = "MyConnection";
			// Prepare a requestor user info object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			UserInfo reqUserInfo = new UserInfo("Admin", "Admin", "Intellica");
			//Create a Layout Manager class object 
			// for report layout management related operations	
			LayoutManager lyoutMger = new LayoutManager();
			//To create new DB connection.
			//Syntax: public void addReportServerConnection(DBConnection dbConn,UserInfo userInfo)             
			//@param DBConnection -  The DBConnection object which is to be created 
			//@param userInfo    -  The current user details 
			//DBConnection object have sufficient information for creating a new connection
			
			lyoutMger.addReportServerConnection(dbConn, reqUserInfo);
		}
		catch (LayoutHandlerException lhe)
		{
			Logger.error("ErrorMessage: " + lhe.Message);
            Logger.error("RootCause	 : " + lhe.RootCause);
		}
		catch (System.Exception e)
		{
            Logger.error("Exception is " + e);
		}
	}
}