//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Delete the dashboard whose dashboard Id is given.

// Import Section
// Use intellica jar to import these classes
using System;
using com.impetus.interaj.globals;
using Enums = com.intellica.client.common.Enums;
using Filter = com.intellica.client.common.Filter;
using UserInfo = com.intellica.client.common.UserInfo;
using Dashboard = com.intellica.client.dashboard.Dashboard;
using DashboardManager = com.intellica.client.dashboard.DashboardManager;
using DashboardPreference = com.intellica.client.dashboard.DashboardPreference;
using DashboardPreferences = com.intellica.client.dashboard.DashboardPreferences;
using DashboardException = com.intellica.client.exception.DashboardException;
using ReportClient = com.intellica.client.init.ReportClient;

//This class is used to delete the dashboard with given Dashboard Id from the Report Server.
//The user would require to provide the DashBoard ID and its identity i.e logged-in User's Credentials.
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Provide the Category ID whose Reports are to be listed
//3) Get all reports from the report server
public partial class Dashboard
{
	public static void DeleteDashboard()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Dashboard rights to perform Dashboard management activities
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
			DashboardManager dManager = new DashboardManager();
			
			//Dashboard Id of the Dashboard i.e. to be deleted from the Repository
            System.String dashBoardId = "E0CBC286-1006-EFCF-089C-ED6EBE95072D";
			
			//This method is used to delete the dashboard specified by the dashboard ID passed as an argument.
			//@param dashboardId : The unique identifier of the dashboard to be deleted.
			//@param userInfo {@link com.intellica.client.common.UserInfo userInfo} object for authorization.
			dManager.deleteDashboard(dashBoardId, requestorUserInfo);
		}
		catch (DashboardException de)
		{
            Logger.error(de);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}