//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Get DashboardPreferenceId of the Dashboard Preferences for the requesting user
// 3) Using that DashboardPreferenceId, delete the Dashboard Preferences

// Import Section
// Use intellica jar to import these classes
using System;
using com.impetus.interaj.globals;
using Enums = com.intellica.client.common.Enums;
using Filter = com.intellica.client.common.Filter;
using UserInfo = com.intellica.client.common.UserInfo;
using DashboardManager = com.intellica.client.dashboard.DashboardManager;
using DashboardPreference = com.intellica.client.dashboard.DashboardPreference;
using DashboardPreferences = com.intellica.client.dashboard.DashboardPreferences;
using DashboardException = com.intellica.client.exception.DashboardException;
using ReportClient = com.intellica.client.init.ReportClient;

//This class is used to delete the Dashboard Preferences of the requestor User.
//The user would require to provide its Credentials.
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Get the DashboardPreferenceId corresponding to that User's Dashbaord Preferences
//3) Using that DashboardPreferenceId, delete the Dashboard Preferences 

public partial class Dashboard
{
	public static void DeleteDashboardPreferences()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			System.Collections.Generic.List<DashboardPreferences> dbPreferencesList = null;
			
			// Create a DashboardManager class object 
			// for Dashboard Management related operations			
			DashboardManager dManager = new DashboardManager();
			
			//Filter object to set filer values for OWNERAPPID, OWNERORGID
			Filter filterObj = new Filter();
			filterObj.setFilterField(Enums.FilterAttrs.DashBoardPreferences.OWNER_APPID, requestorUserInfo.UserId);
			filterObj.setFilterField(Enums.FilterAttrs.DashBoardPreferences.OWNER_ORGID, requestorUserInfo.OrgID);
			
			//get the Dashboard Preference list for that user.
			dbPreferencesList = dManager.getDashBoardPreferences(filterObj, requestorUserInfo);
			
			//get the dashboard Preferences object
			DashboardPreferences dbPrefs = (DashboardPreferences) dbPreferencesList[0];
			
			//This method is used to delete the Dashboard Preferences specified by the Dashboard data passed as argument..
			//@param dashboardPreferenceID The Preference Id corresponding to the Requestor User
			//@param requestorUserInfo The information about the user for which the Dashboard Preferences are to be deleted. The {@link com.intellica.client.common.UserInfo requestorUserInfo} object for authorization.
			dManager.deleteDashBoardPreference(dbPrefs.DashBoardPreferenceId, requestorUserInfo);
			
			Logger.debug("Dashboard Preferences Deleted Successfully--");
		}
		catch (DashboardException de)
		{
            Logger.error(de);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}