//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Provide Dashboard Id whose detail is to be obtained

// Import Section
// Use intellica jar to import these classes
using System;
using com.impetus.interaj.globals;
using Enums = com.intellica.client.common.Enums;
using Filter = com.intellica.client.common.Filter;
using UserInfo = com.intellica.client.common.UserInfo;
using CustomDashboard = com.intellica.client.dashboard.Dashboard;
using DashboardManager = com.intellica.client.dashboard.DashboardManager;
using DashboardException = com.intellica.client.exception.DashboardException;
using ReportClient = com.intellica.client.init.ReportClient;

//This class is used to get the detail about the given Dashboard.
//The user would require to provide the Dashboard ID and its identity i.e UserInfo. 
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Provide the Dashboard ID for getting its details
public partial class Dashboard
{
	public static void GetDashboardDetails()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			//UPGRADE_TODO: Constructor 'java.io.FileInputStream.FileInputStream' was converted to 'System.IO.FileStream.FileStream' which has a different behavior. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javaioFileInputStreamFileInputStream_javalangString'"
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
			DashboardManager dManager = new DashboardManager();
			
			System.Collections.ArrayList dashBoardList = new System.Collections.ArrayList();
			
			//Dashboard Id of the dashboard whose details are to be obtained
            System.String DashboardId = "8E8ABA2C-EF2A-3A9F-C992-5B913C6C26EB";
			
			//This method is used to get the requested DashBoard Object whose ID is passed as an argument.
			//@param dashboardId: The unique identifier of the dashboard for which the details are to be obtained from the Report Server.
			//@param userInfo:  {@link com.intellica.client.common.UserInfo userInfo} object for authorization to get DashBoard..
			//@return Dashboard {@link com.intellica.client.dashboard.DashBoard2 DashBoard2} object containing dashboard details
            CustomDashboard dashboard = dManager.getDashBoardDetails(DashboardId, requestorUserInfo);

            Logger.debug("Dashboard's Name = " + dashboard.PatternName);
            Logger.debug("Dashboard's Category = " + dashboard.CategoryName);
            Logger.debug("Public Dashboard = " + dashboard.IsPublic);
            Logger.debug("Dashboard's Access Rights = " + dashboard.AccessRights);
            Logger.debug("Dashboard's Description = " + dashboard.Description);
		}
		catch (DashboardException de)
		{
            Logger.error(de);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}