//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Get Reports list for a given category from the report server 

// Import Section
// Use intellica jar to import these classes
using System;
using com.impetus.interaj.globals;
using Filter = com.intellica.client.common.Filter;
using UserInfo = com.intellica.client.common.UserInfo;
using Enums = com.intellica.client.common.Enums;
using CustomDashboard = com.intellica.client.dashboard.Dashboard;
using DashboardManager = com.intellica.client.dashboard.DashboardManager;
using DashboardException = com.intellica.client.exception.DashboardException;
using ReportClient = com.intellica.client.init.ReportClient;
using LayoutManager = com.intellica.client.layout.LayoutManager;

//This class is used to get the list of Dashboards.
//The user would require to provide its credentials.
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Get dashboard list based on the filter set from the report server
public partial class Dashboard
{
	public static void GetDashboardList()
	{
		try
		{			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
			DashboardManager dManager = new DashboardManager();
            System.Collections.Generic.List<CustomDashboard> dashBoardList = new System.Collections.Generic.List<CustomDashboard>();
			
			Filter filterObj = new Filter();
			//To get the Dashboard list
			filterObj.setFilterField(Enums.Filters.EntityList.ENTITYTYPE, Enums.Filters.EntityList.EntityType.DASHBOARD2);
			
			//To get Complete list of Dashboards i.e. present at root and other categories, then set this filter value as COMPLETE.
			//If set as CURRENT_LEVEL, only Dashboards present at Root are listed and if CategoryId is also given, then Dashboards present in that Category will be listed, but not all.
			filterObj.setFilterField(Enums.Filters.EntityList.DEPTH, Enums.Filters.EntityList.Depth.COMPLETE);
			
			//To get Category list for given Category.
            filterObj.setFilterField(Enums.Filters.EntityList.CATEGORYID, "571937DE-9934-90CB-FFD0-371470A44B7E");
			
			dashBoardList = dManager.getDashboardList(filterObj, requestorUserInfo);
			
			System.Collections.IEnumerator itr = dashBoardList.GetEnumerator();
			while (itr.MoveNext())
			{
                CustomDashboard dashboard = (CustomDashboard)itr.Current;
                Logger.debug("Dashboard's Category = " + dashboard.CategoryName);
                Logger.debug("Dashboard's Name = " + dashboard.DashBoardId);
                Logger.debug("Dashboard's Pattern Name = " + dashboard.PatternName);
                Logger.debug("Dashboard's Public/Private = " + dashboard.IsPublic);
                //Logger.debug();
			}
		}
		catch (DashboardException de)
		{
            Logger.error(de);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}