//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// Import Section
// Use intellica jar to import these classes
using System;
using com.impetus.interaj.globals;
using Enums = com.intellica.client.common.Enums;
using Filter = com.intellica.client.common.Filter;
using UserInfo = com.intellica.client.common.UserInfo;
using DashboardManager = com.intellica.client.dashboard.DashboardManager;
using DashboardPreference = com.intellica.client.dashboard.DashboardPreference;
using DashboardPreferences = com.intellica.client.dashboard.DashboardPreferences;
using DashboardException = com.intellica.client.exception.DashboardException;
using ReportClient = com.intellica.client.init.ReportClient;

//This class is used to set dashboards in preference list.
//The user would require to provide its User Credentials.The user would also require to provide a Dashboard preference id which is unique for every dashboard if multiple dashboards
//are to be set in the preference list. The user is laso required to provide the dashboard id to be set in the preference listas well as the to provide a pattern name for the dashboard.
//The dashboard name to be set in the preference list and the dashboard pattern name need not be same.
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Get Dashboard list present in its Preferences.
public partial class Dashboard
{
	public static void SetDashboardPreferences()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//Create an instance of DashboardPreferences
			DashboardPreferences dbPrefs = requestorUserInfo.DashBoard2Preferences;

			DashboardPreference dbObj1 = null;
						
			Filter filterObj = new Filter();
			filterObj.setFilterField(Enums.FilterAttrs.DashBoardPreferences.OWNER_APPID, requestorUserInfo.UserId);
			filterObj.setFilterField(Enums.FilterAttrs.DashBoardPreferences.OWNER_ORGID, requestorUserInfo.OrgID);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
			DashboardManager dManager = new DashboardManager();

            System.String dashboardId = "8E8ABA2C-EF2A-3A9F-C992-5B913C6C26EB";
			System.String dashboardName = "Sales Review";
			System.String dashboardPrefId = "1211245"; //unique id
			int sequenceNo1 = 0;
			
			//Constructor which takes as parameters the Unique Identifier of DashBoard and its sequence number in the list of user's DashBoard Pereferences. 
			// Syntax : public DashBoardPreference(java.lang.String dashBoardId, int sequenceNumber)Constructor which takes as parameters the Unique Identifier of DashBoard and its sequence number in the list of user's DashBoard Pereferences. 
			// @param dashBoardId - Unique Identifier of DashBoard.
			// @param sequenceNumber - The sequence number of the DashBoard in the user preference..
			
			dbObj1 = new DashboardPreference(dashboardId, sequenceNo1);
			dbObj1.DashBoardPatternName = dashboardName;
			
			//Arraylist to store objects of DashboardPreference 
            System.Collections.Generic.List<DashboardPreference> prefList = new System.Collections.Generic.List<DashboardPreference>();
			
			//Adding DashboardPreference Objects.
			prefList.Add(dbObj1);
			//prefList.add(dbObj2);
			/*
			* This method is used to set the unique identifier for the user's dashboard preferences.
			*
			* @param dashBoardPreferenceId The unique identifier for the user's dashboard preferences.
			*/
            if (dbPrefs == null)
                dbPrefs = new DashboardPreferences(dashboardPrefId);

			dbPrefs.DashBoardPreferenceId = dashboardPrefId;
			/*
			* This Method is used to set List of all {com.intellica.client.personalization.DashboardPreference DashboardPrefrence} instances
			* @param dashBoardPreferenceList ArrayList of all {com.intellica.client.personalization.DashboardPreference DashboardPrefrence} instances
			*/
			dbPrefs.DashBoardPreferenceList = prefList;
			/*
			* This method is used to set the Dashboard Preferences for the requestor user.
			*
			* @param dashboardPreferences The {@link com.intellica.client.dashboard.DashboardPreferences DashboardPreferences}
			* object specifying the Dashboard Preference to be set for the user.
			* 
			* @param requestorUserInfo The information about the user for which the Dashboard Preferences are to be set. Also
			* the {@link com.intellica.client.common.UserInfo userInfo} object for authorization.
			*/
			dManager.saveDashboardPreferences(dbPrefs, requestorUserInfo);
		}
		catch (DashboardException de)
		{
            Logger.error(de);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}