//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using EntityOperation = com.intellica.client.common.EntityOperation;
using UserInfo = com.intellica.client.common.UserInfo;
//Object used to pass in run report.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
//Has Init Method.
using LayoutManager = com.intellica.client.layout.LayoutManager;

// for report layout management related operations	
/// <summary> 
/// This class is used to make copies of existing Query Objects to another destination Category with 
/// given Category ID 
/// </summary>
public partial class MassOperation
{
	public static void  CopyEntities()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			//UPGRADE_TODO: Constructor 'java.io.FileInputStream.FileInputStream' was converted to 'System.IO.FileStream.FileStream' which has a different behavior. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javaioFileInputStreamFileInputStream_javalangString'"
            System.IO.Stream is_Renamed = new System.IO.FileStream("<ReportClient.properties_Absolute Path>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			// @param userId   - : Id of the User Logged-In.
			// @param password - : Password of the User Logged-In.
			// @param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			// Create a Layout Manager class object 
			// for layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			//Category ID of the Destination Category where the Entities(Query Objects) are to be Copied.
            System.String destCategoryId = "AC677CD9-9EE5-A0E2-8FDA-36A9B0198D1C";

            System.String[] queryIds = new System.String[] { "73FC732B-9512-C3F7-F1FA-6BEACD056E43" };
			
			//Arraylist used to store entity objects.
			System.Collections.ArrayList entityList = new System.Collections.ArrayList();
			
			EntityOperation entityObj = null;
			
			for (int i = 0; i < queryIds.Length; i++)
			{
				entityObj = new EntityOperation();
				//Entity Type could be REPORT /CATEGORY /QUERY /DASHBOARD2/
				//PARAMETER /SAVEDREPORT /DASHBOARD_WIDGET /CUBEOBJECT
                entityObj.EntityType = "REPORT";
				entityObj.EntityId = queryIds[i];
				entityList.Add(entityObj);
			}
			// Method to copy the Entities(Query Objects) to another Category
			// @param 1 : entityList : Arraylist containing Query Objects  
			// @param 2 : destinationCategoryId - destination category id,where queries are to be copied.
			// @param 3 : requestorUserInfo - UserInfo object for authorization. 
			lm.copyEntities(entityList, destCategoryId, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
            Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//iie.printStackTrace();
		}
		catch (LayoutHandlerException lhe)
		{
            Logger.error(lhe);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}