//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
 
using System;
using com.impetus.interaj.globals;
using EntityOperation = com.intellica.client.common.EntityOperation;
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;

// for report layout management related operations			
	
/// <summary> 
/// This class is used to delete existing Entities (Categories) whose Entitity Ids are provided.  
/// </summary>
public partial class MassOperation
{
	public static void DeleteEntities()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<ReportClient.properties_Absolute Path>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			// @param userId   - : Id of the User Logged-In.
			// @param password - : Password of the User Logged-In.
			// @param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			// Create a Layout Manager class object 
			// for layout management related operations			
			LayoutManager lm = new LayoutManager();

            System.String[] categoryIds = new System.String[] { "1B75AB7B-4382-80A6-FC81-F832E1793CB4" };
			
			//Arraylist to store Category Objects
			System.Collections.ArrayList entityList = new System.Collections.ArrayList();
			EntityOperation entityObj = null;
			
			for (int i = 0; i < categoryIds.Length; i++)
			{
				entityObj = new EntityOperation();
                entityObj.EntityType = "REPORT";
				entityObj.EntityId = categoryIds[i];
				entityList.Add(entityObj);
			}
			// Method to delete the Entities from Repository
			// @param 1 : entityList - Arraylist containing Entity(Category) Objects
			// @param 2 : requestorUserInfo - UserInfo object for authorization. 
			lm.deleteEntities(entityList, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (LayoutHandlerException lhe)
		{
            Logger.error(lhe);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}