// This program adds a new organisation and sets the authentication mode.
//The user would require to provide its identity i.e. user Info to authorize for creating Organization..

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

// Import Section
using System;

using SecurityManager = com.intellica.client.security.SecurityManager;
//for getting the controller information for all Administration related operations
using UserInfo = com.intellica.client.common.UserInfo;
//For getting user information
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using OrgInfo = com.intellica.client.security.OrgInfo;
//Used for getting organisation information
using Authentication = com.intellica.client.security.Authentication;
// Used for setting Authentication mode 

//This class 
// 1) Creates a userInfo Object of current logged in User.
// 2) Sets Host authentication mode for the organization.
// 2) Add an organization in the Intellicus application.

public partial class Organization
{
	
	public static void  AddOrg()
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requesterUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			
			// Create an OrgInfo object by setting organization Id.
			System.String organisationId = "TestOrg";
			OrgInfo addOrg = new OrgInfo(organisationId);
			
			// Set authentication mode for the organization.
			// Set authentication mode as Host if authentication check is performed by main application.
			// for single sign-on 
			
			Authentication authInfo = new Authentication();
			//public void setAuthenticateMode(int authenticateMode)
			//Authentication Mode Id values 1=Host Application
			//                              2= Intellica
			//                              3=External Application.
			//This identifies who will authenticate the users/roles belonging to this organization. 
			//@param authenticateMode - Authentication Mode Id's value
			
			authInfo.AuthenticateMode = com.intellica.client.common.Enums.SecurityTypes.Authentication.HOSTAPP;
			//public void setAuthenticationObj(Authentication authentication)sets the Authentication object.
			//Authentication object keeps the data of tag attributes and data of inner tag . 
			//@param  authInfo -object of Authentication class
			addOrg.AuthenticationObj = authInfo;
			
			// This will send request to the server for adding organization.
			//Syntax - public void addOrganization(OrgInfo orgInfo,UserInfo userInfo)
			//                                    throws ISecurityException
			//@param orgInfo - The Organization details
			//@param userInfo - The User details 
			sMgr.addOrganization(addOrg, requesterUserInfo);
		}
		catch (ISecurityException ise)
		{
            throw new Exception("Failed to add the organization as the organization with the same id must be existing");
		}
		catch (System.Exception e)
		{
            throw new Exception(e.Message);
		}
	}
}