// This program is to delete an organization from the Intellicus repository.
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// 
/// This source code is provided without any express or implied warranties whatsoever
/// 
/// *
/// </summary>


// Import Section
using System;
// Use intellica jar to import these classes
using SecurityManager = com.intellica.client.security.SecurityManager;
//for getting the controller information for all Administration related operations
using UserInfo = com.intellica.client.common.UserInfo;
//For getting user information
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using OrgInfo = com.intellica.client.security.OrgInfo;
//Used for getting organisation information>

//This class deletes an existing organisation from the Intellicus repository.The user requesting for deleting the organization 
//should have the rights to delete the organization and is required to provide the organisation id.
public partial class Organization
{
	public static void  DeleteOrg()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application and should have the rights to delete the organisation.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requesterUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			//This gets Organization which is to be deleted	
			//Syntax :public OrgInfo getOrganizationById(String orgId,UserInfo userInfo)
			//@param orgId - Id of the requested OrgInfo object
			//@param userInfo - The current user details 
			System.String organizationId = "TestOrg";
			OrgInfo delOrg = sMgr.getOrganizationById(organizationId, requesterUserInfo);
			
			//This  Deletes the Organization from the Intellicus Repository.
			//Syntax :public void deleteOrganization(OrgInfo orgInfo,UserInfo userInfo)
			//                                       throws ISecurityException
			//@Param orgInfo  : The Organization details
			//@param userInfo : The current user details
			sMgr.deleteOrganization(delOrg, requesterUserInfo);
		}
		catch (ISecurityException ise)
		{
            throw new Exception("The Organization with given details was not found");
		}
		catch (System.Exception e)
		{
            throw new Exception(e.Message);
		}
	} // End of main function
}