// This program returns the list of all organizations created in Intellicus repository
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary>
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
// Use intellica dll to import these classes

using System;
using SecurityManager = com.intellica.client.security.SecurityManager;
//for getting the controller information for all Administration related operations
using UserInfo = com.intellica.client.common.UserInfo;
//For getting user information
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using OrgInfo = com.intellica.client.security.OrgInfo;
using com.impetus.interaj.globals;

//Used for getting organisation information>
// Array List manipulation

//This class gets the list of all organizations created in Intellicus repository
public partial class Organization
{
    public static void GetOrgList()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			//An arraylist created to hold the list of organisations in it. 
			System.Collections.ArrayList arrList = new System.Collections.ArrayList();
			
			//This method returns the list of all organizations created in Intellicus repository
			//Syntax public ArrayList getOrgList(UserInfo userInfo)throws ISecurityException
			//@param   userInfo-information about the current user or who is requesting 
			//         to get the list of organizations.
			arrList = sMgr.getOrgList(requestorUserInfo);
			Logger.debug("List of organizaion is..");
			
			//This will get and print organization one by one. 
			for (int i = 0; i < arrList.Count; i++)
			{
				int count = i + 1;
				OrgInfo org = new OrgInfo();
				org = (OrgInfo) arrList[i];
                Logger.debug("\n\n\nOrganizaion" + count + ":" + org.OrgId);
			}
		}
		catch (ISecurityException ise)
		{
			throw new Exception("connection cannot be established with the engine or " + "read or write operation cant be performed from or to the engine or" + "some error has occured while executing the request on the engine or" + "If the response xml obtained from server cannot be parsed");
		}
		catch (System.Exception e)
		{
            throw new Exception(e.Message);
		}
	} // End of main function
}