// This program is to get list of users for the given organization 
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has user management methods
using UserInfo = com.intellica.client.common.UserInfo;
// user info bean 
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
using com.impetus.interaj.globals;
// Has Init Method
//for arrayList operations.

//This will get the list of users for a given organisation.User required to provide the
//organisation id,whose list of users the requesting user wants to retrieve.
public partial class Organization
{
    public static void GetUserListForOrg()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// This user must have Admin rights to perform user management actions
			// such as create user
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			//This Variable is created for getting User List for specified Organization
			System.Collections.ArrayList arrList = new System.Collections.ArrayList();
			System.String orgId = "Intellica"; //Get the list of users for this Organization.
			
			//This will get the users list for specified Organization.
			//Syntax public ArrayList getUserListForOrganization(String orgId,
			//UserInfo userInfo)throws ISecurityException
			//@param orgId - of the userInfo list to be retrieved. 
			//@param requestorUserInfo-Information about the user that is requesting for getting 
			//                         the list of users.
			arrList = sMgr.getUserListForOrganization(orgId, requestorUserInfo);
			
			for (int i = 0; i < arrList.Count; i++)
			{
				int count = i + 1;
				UserInfo usr = (UserInfo) arrList[i];
				Logger.debug("\n\n\nUSER" + count + ":" + usr.UserId);
			}
		}
		catch (ISecurityException ise)
		{
			new Exception("The Organization with the given details was not found");
		}
		catch (System.Exception e)
		{
			new Exception(e.Message);
		}
	} // End of main function
}