// This program is to modify the organization details. 
//The user would require to provide its identity i.e. user Info to authorize for modifying Organization..

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary>
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using Authentication = com.intellica.client.security.Authentication;
using SecurityManager = com.intellica.client.security.SecurityManager;
//for getting the controller information for all Administration related operations
using UserInfo = com.intellica.client.common.UserInfo;
//For getting user information
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using OrgInfo = com.intellica.client.security.OrgInfo;
//Used for getting organisation information>

//This class retrieves the organisation as an object modify the organisation details.User required to provide the organisation id,that
//required to be modified.And the user required to have the rights to modify the organisation.
public partial class Organization
{
    public static void ModifyOrg()
	{
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requesterUserInfo = new UserInfo(userId, password, organization);
			
			//Method will return the organization having the given orgId to do any kind of modifications on it.
			//Syntax:public OrgInfo getOrganizationById(String orgId,UserInfo userInfo)
			//                                                    throws ISecurityException
			//@param orgId    : Id of the requested OrgInfo object
			//@param userInfo : The current user details 
			System.String organisationId = "testOrg";
			OrgInfo modOrg = sMgr.getOrganizationById(organisationId, requesterUserInfo);
			
			//Syntax public void setCanDelete(boolean canDelete)
			//@param canDelete - : determines whether organization can be deleted or not.
			//                     The value is true if organization can be deleted else false.
			modOrg.CanDelete = true;
			// This will update Organization description.
			System.String description = "Modified organization description 3rd time.....";
			modOrg.OrgDescription = description;
			
			/*
			* public void setAuthenticateMode(int authenticateMode)
			*Authentication Mode Id values 
			*1= Host Application ; 2= Intellica;3=External Application.
			*
			* This identifies who will authenticate the users/roles belonging to this
			* organization.
			*
			*@param authenticateMode : Authentication Mode Id's value
			*/
			Authentication authInfo = new Authentication();
			authInfo.AuthenticateMode = com.intellica.client.common.Enums.SecurityTypes.Authentication.REPORTINGSYS;
			authInfo.PWNeverExpires = false;
			/* Set whether the to change password id enforced for the organization 
			* @param pwdChangeEnforced : values:0/1
			* 0 for false
			* 1 for true
			* public void setPWDChangeEnforced(String pwdChangeEnforced)
			*/
			authInfo.PWDChangeEnforced = "0";
			/*
			*@param pwLength : String which contains the minimum password length for 
			*users and roles belonging to this organization
			* public void setPasswordLength(String pwLength)
			* @param pwExpirationDays : The number of days after which the password for 
			* or users and roles  of the organization will expire if it is 
			* not changed.
			*/
			authInfo.PasswordLength = "4";
			/*
			* public void setPasswordExpDays(String pwExpirationDays){
			*/
			authInfo.PasswordExpDays = "4";
			/*
			*  sets the <code>Authentication</code> object.
			* <code>Authentication</code> object keeps the data of 
			* <AUTHINFO> tag attributes and data of inner tag <AUTHENTICATION>.
			* @param authentication -object of <code>Authentication</code> class 
			* public void setAuthenticationObj(Authentication authentication)
			*/
			modOrg.AuthenticationObj = authInfo;
			
			//This Modifies an Organization at the Report Engine 
			//Syntax public void modifyOrganization(OrgInfo orgInfo,UserInfo userInfo)
			//                                    throws ISecurityException
			//@param orgInfo - : The Organization details
			//@param requestorUserInfo - : The current user 
			sMgr.modifyOrganization(modOrg, requesterUserInfo);
		}
		catch (ISecurityException ise)
		{
			throw new Exception("The Organization with the given details was not found");
		}
		catch (System.Exception e)
		{
            throw new Exception(e.Message);
		}
	} // End of main function
}