//This API is used to copy an existing report to another Destination Category.
//This would require user to provide UserInfo to authorize for performing Reports related activities.
//User need to provide the ReportID that is to be copied and the Destination Category ID where it is to be Copied.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
// for report layout management related operations			
using Report = com.intellica.client.reportutils.Report;
using com.impetus.interaj.globals;

//Class contains the details of the irl file. 
/// <summary> 
/// This class is used to make a copy of the existing report attributes to another destination Category with 
/// given Category ID 
/// </summary>
public partial class ReportLayoutMgr 
{
    public static void CopyReport()
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			// @param userId   - : Id of the User Logged-In.
			// @param password - : Password of the User Logged-In.
			// @param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Report class contains the details of the irl file. 
			// This is the default constructor to create report object.
			Report r = new Report();
			
			// If want to Assign name to the copied report in the destination Category.
			// If not Given , then by default it takes the same name as that in the Source Category.
			r.MenuName = "CopiedCopy3";
			
			
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			//ReportId that is to be Copied
            System.String sourceReportId = "Copy3";
			
			//Category ID of the Destination Category where the Report is to be Copied.
            System.String destCategoryId = "6D564906-18CE-43FB-930C-DFB2D44792B3";
			
			// Method to copy the report to anther Category
			// @param 1 : sourceReportId - source report id that is to be copied,mandatory argument for copying the report.
			// @param 2 : destinationCategoryId - destination category id q,where new report has to be copied.if this is null then source report's category id will be taken as destination category.
			// @param 3 : report - instance of Report class for copy.
			// @param 4 : requestorUserInfo - UserInfo object for authorization. 
			lm.copyReport(sourceReportId, destCategoryId, r, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.error("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (LayoutHandlerException lhe)
		{
            Logger.error("Unable to copy report");
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}