// This program 
// 1) Copies the Source Report(Given Source ReportId) in the given existing Destination Category.
// 2) Create a new Query Object same as that of the Source Report just differing in its name.
// 3) Grant Organization specific Access Rights to the newly created Query Object.
// 4) Update the Copied Report by modifying the Query Object of Copied Report which is newly created.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;

//A ByteArrayInputStream contains an internal buffer that contains bytes that may be read from the stream.
using AdhocLayoutManager = com.impetus.intera.layout.adhoc.AdhocLayoutManager;
//This Class is responsible for managing following type of request
//Fetching Saved Adhoc Report layout for given report id
//Fetching configuration information from its property file
using AdhocReportLayout = com.impetus.intera.layout.adhoc.AdhocReportLayout;
//It holds informatiom about DataSource,Template,Filters,Groups,Charts,
using SQLEditor = com.impetus.intera.layout.sqleditor.SQLEditor;
//This class contains properties and parsing logic for the SQLEDITOR of the report.
using QueryObject = com.impetus.intera.reportobjects.QueryObject;
// This class contains all the details about the query object.
using ReportObject = com.impetus.intera.reportobjects.ReportObject;
//This class is super class of all the report objects
using ReportObjectException = com.impetus.intera.reportobjects.ReportObjectException;
using ReportObjectManager = com.impetus.intera.reportobjects.ReportObjectManager;
//This class is used for Report Object related operations.
using Enums = com.intellica.client.common.Enums;
// Has Enums for the constants used
using UserInfo = com.intellica.client.common.UserInfo;
// user info bean
using ISecurityException = com.intellica.client.exception.ISecurityException;
// For exceptions during user management
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
// for report layout management related operations
using Report = com.intellica.client.reportutils.Report;
//Class contains the details of the irl file.
using EntityAccessRight = com.intellica.client.security.EntityAccessRight;
//has Entity Access Rights mechanism
using EntityInfo = com.intellica.client.security.EntityInfo;
//For assigning to Organization
using Utility = com.intellica.client.utils.Utility;
// has getGUID(), used to auto-generate ReportId.
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has user management methods
using AppInfo = com.intellica.client.security.AppInfo;
//for creating AppInfo instance
using com.impetus.interaj.globals;

/// <summary>
/// This class copies a Report into destination Category and then modifies its Data source. 
/// </summary>
public partial class ReportLayoutMgr  
{
    public static void CopyReportWithModifiedQO()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo userInfo = new UserInfo(userId, password, organization);
			
			//Report Id of the report that is to be copied.
            System.String reportID = "A5E2B7D9-AF9C-FE6D-8377-D64AFA3F2938";
			//Destination Category wahere the report is to be copied.
            System.String destinationCat = "93538096-012F-EC52-9F96-58C8687EDD00";
			
			//copyRptToDomain(String reportName, String srcReportId, String domain, UserInfo userInfo)
			//@param reportName : Report Name of the Report i.e. to be copied in the destination Category
			//@param srcReportId : Report Id of the report that is to be copied.
			//@param domain : Destination Category wahere the report is to be copied.
			//@param userInfo : UserInfo of the Requestor User.
            string strRptName = "CopyReport";
            copyRptToDomain(strRptName, reportID, destinationCat, userInfo, organization);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
	//Method used to perform copy Report Operation and update the report by changing its Data Source.
	private static Report copyRptToDomain(System.String reportName, System.String srcReportId, System.String domain, UserInfo userInfo, System.String strOrgId)
	{
		//Local object of Report containing attributes of copied Report
		Report copiedReport = null;
		
		//Create a Layout Manager class object 
		// for report layout management related operations			
		LayoutManager lm = new LayoutManager();
		
		//This class contains method to get/replace/add/delete a Query object(QO)
		ReportObjectManager rom = new ReportObjectManager();
		
		//Object of Source Report that is to be copied.
		Report srcRpt = null;
		
		//Objet of new Copied Report 
		Report newReport = null;
		
		//Object of QueryObject i.e bound to the Source Report.
		QueryObject srcQO = null;
		
		//Object of QueryObject i.e modified for the Copied Report.
		QueryObject newQO = null;
		
		//Report Id of the copied Report
		System.String destReportId = null;
		
		//It holds informatiom about DataSource,Template,Filters,Groups,Charts,
		//Matrix,Sumarries,Sort-orders used for desiging this Adhoc Report.
		AdhocReportLayout adhocReportLayout = new AdhocReportLayout();
		
		//This Class is responsible for managing following type of request
		//Fetching Saved Adhoc Report layout for given report id
		//Fetching configuration information from its property file
		AdhocLayoutManager adhocManager = null;
		
		try
		{
			//System Generated Reporrt Id through getGUID() for destination Report 
			destReportId = Utility.getGUID();
			
			/***** Code to get the QO of the Source Report *************/
			
			//Get the IRL Bytes of the Source Report.
			byte[] reportIRL = lm.getIRLFile(srcReportId, userInfo);
			
			//Parse the xml of IRL Bytes 
			adhocReportLayout.parseXml(new System.IO.MemoryStream(reportIRL));
			
			//Get the Data Source(QO) of the Report through parsed xml. 
			System.String srcQOId = adhocReportLayout.getDataSource().Id;
			
			//Getting object of Query Object of Source Report.
			srcQO = (QueryObject) rom.getReportObject(Enums.IRO.TYPE.QUERY, srcQOId, userInfo);
			srcRpt = lm.getReportDetails(srcReportId, userInfo);
			/****************************************************************/
			
			/******* Creating a new Query and adding itinto Repository ***********************************/
			//Creating new Query Object for copied Report and setting its attributes
			newQO = (QueryObject) ReportObject.createReportObject(Enums.IRO.TYPE.QUERY);
			newQO.Id = Utility.getGUID();
            newQO.Name = srcQO.Name + "_" + domain;
			newQO.Source = "SQL";
			newQO.ConnectionType = srcQO.ConnectionType;
			newQO.ConnectionName = srcQO.ConnectionName;
			SQLEditor sqlEditor = newQO.SqlEditor;
			newQO.ColumnDetails = srcQO.ColumnDetails;
			sqlEditor.setSQL(srcQO.SqlEditor.getSQL(), true);
            newQO.Name = srcQO.Name + "_" + domain;
			
			//Add the Report Object in the Repository
			rom.addReportObject(newQO, userInfo);
			/****************************************************************/
			
			/********** Assigning Access Rights to Query Object **************/
			//Assigning Organization based Access Rights to the Query Object 
			EntityAccessRight ear = new EntityAccessRight();
			ear.AccessLevel = 1; //1 : Gives rights to Everyone, 0 : No-one
			
			//AppInfo(String appId, String orgId) 
			//constructor for creating AppInfo instance.
			//Assigning to a particular Organization
			//@param appId : Application Type. Leave it blank for all the Users and Roles of the Organization
			//@param orgId : Organization Id whose access rights are to be set.
            AppInfo ai = new AppInfo("", strOrgId);
			ear.AppInfo = ai;
			
			//Set the access rights for Querry Object
			EntityInfo ei = new EntityInfo(newQO.Id, "QO");
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sManager = SecurityManager.Instance;
			
			//This API allows the user to assign access rights information to 
			//a user/role/organization or Everyone on an entity. 
			sManager.grantEntityPrivileges(ei, ear, userInfo);
			/****************************************************************/
			
			/****** Copying the Source Report to Destination Category *******/
			//Setting the attributes for copied Report 
			copiedReport = new Report();
			copiedReport.MenuName = srcRpt.MenuName;
			copiedReport.DesignMode = "ADHOC";
			copiedReport.IsPublic = true;
			copiedReport.IsHidden = false;
			copiedReport.ReportId = destReportId;
			copiedReport.DBConnection = srcRpt.DBConnection;
            copiedReport.OwnerOrgId = strOrgId;
			lm = new LayoutManager();
			
			//Method to make a copy of the existing report attributes. 
			//Syntax : public void copyReport(String sourceReportId,String destinationCategoryId,Report report,UserInfo userInfo)
			//@param sourceReportId - source report id,mandatory argument for copying the report.
			//@param destinationCategoryId - destination category id,where new report has to be copied.if this is null then source report's category id will be taken as destination category.
			//@param report - instance of Report class for copy.
			//@param userInfo - UserInfo object for authorization. 
			lm.copyReport(srcReportId,domain, copiedReport, userInfo);
			/****************************************************************/
			
			/********** Updating Copied Report by changing Data Source ******/
			adhocManager = new AdhocLayoutManager();
			adhocReportLayout = adhocManager.getAdhocReport(destReportId, userInfo);
			
			//Set the data source of the adhoc Report Layout 
			adhocReportLayout.getDataSource().Id = newQO.Id;
			adhocReportLayout.getDataSource().Name = newQO.Name;
			
			//Setting the attributes of newly copied Report i.e Report Id and IRL Bytes containing newly 
			newReport = new Report();
			newReport.ReportId = destReportId;
            newReport.IRLBytes = System.Text.Encoding.UTF8.GetBytes(adhocReportLayout.Xml);
			
			// Method to modify/update the report object for it's menu name and IRL file content.
			lm.updateReport(copiedReport, newReport, userInfo);
			/*****************************************************************/
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (LayoutHandlerException e)
		{
			Logger.error("LayoutHandlerException: Failed copying report [" + reportName + "] to domain[" + domain + "]");
			try
			{
				rom.deleteReportObject(newQO, userInfo);
			}
			catch (ReportObjectException roe)
			{
				Logger.error("ReportObjectException: Failed deleting QO [" + newQO.Name + "] to domain[" + domain + "]");
			}
			copiedReport = null;
		}
		catch (ISecurityException ise)
		{
			Logger.error(ise);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
			Logger.debug("Exception: Failed copying report [" + reportName + "] to domain[" + domain + "]");
			try
			{
				rom.deleteReportObject(newQO, userInfo);
			}
			catch (ReportObjectException roe)
			{
				Logger.debug("ReportObjectException: Failed deleting QO [" + newQO.Name + "] to domain[" + domain + "]");
			}
			copiedReport = null;
		}
		return copiedReport;
	}
}