/*
* This API is used to Delete an existing report from the Intellicus Repository.
* This would require user to provide UserInfo to authorize for performing Reports related activities.
* User need to provide :
* ReportID(Mandatory) - ReportId of the Report that is to be Deleted.
*/

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
/// 
using System;
using UserInfo = com.intellica.client.common.UserInfo;
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
using ReportClient = com.intellica.client.init.ReportClient;
using LayoutManager = com.intellica.client.layout.LayoutManager;
using com.impetus.interaj.globals;
/// <summary> 
/// This class is used to delete an existing report from the Reporsitory. 
/// given Report ID which is to be deleted. 
/// </summary>
public partial class ReportLayoutMgr  
{
    public static void DeleteReport()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			// @param userId   - : Id of the User Logged-In.
			// @param password - : Password of the User Logged-In.
			// @param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo userInfo = new UserInfo(userId, password, organization);
			
			//ReportId of the Report that is to be Deleted
            System.String reportId = "8C612655-6AE7-2B9D-39E2-99481F9000A4";
			
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			try
			{
				// Method to delete the report
				lm.deleteReportLayoutRow(reportId, userInfo);
			}
			catch (LayoutHandlerException e)
			{
				Logger.error(e);
			}
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}