//This API is used to obtain the detalis of the Report with given Report ID.
//User need to provide the ReportID whose details is to be obtained.
//This would require user to provide UserInfo to authorize for Reports related Activites.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
/// 
using System;
using UserInfo = com.intellica.client.common.UserInfo;
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using LayoutHandlerException = com.intellica.client.exception.LayoutHandlerException;
//This Exception class is used for all Layout use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
//For all report layout operations client creates the object of this class.
using Report = com.intellica.client.reportutils.Report;
using com.impetus.interaj.globals;

//This class contains details of irl file.
/// <summary> 
/// This class  is used to obtain the detalis of the Report, when Report ID is given.  
/// Method used for this purpose returns an object of Report class obtained from the report server
/// </summary>
public partial class ReportLayoutMgr  
{
    public static void GetReportDetails()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			// Report class contains the details of the irl file. 
			// This is the default constructor to create report object.
			Report reportDetail = new Report();
			
			// ReportID whose Report Details are required
            System.String reportId = "A5E2B7D9-AF9C-FE6D-8377-D64AFA3F2938";
			
			//@param 1 : reportId - The report id whoes details are to be obtained.
			//@param 2 : userInfo - UserInfo for authorization. 
			reportDetail = lm.getReportDetails(reportId, requestorUserInfo);
			
			
			// Get the Deatils of the Report
			Logger.debug("Category Name of Report : " + reportDetail.CategoryMenuName);
			Logger.debug("Report Name : " + reportDetail.ReportName);
			Logger.debug("Date of Creation : " + reportDetail.RepositDate);
			Logger.debug("Priority of Report : " + reportDetail.Priority);
			Logger.debug("Category Name of Report : " + reportDetail.CategoryMenuName);
			Logger.debug("Description of Report : " + reportDetail.Description);
			Logger.debug("Deployment Type of Report : " + reportDetail.DeploymentType);
			Logger.debug("Design Mode of Report : " + reportDetail.DesignMode);
		}
		catch (InterfaceInitException iie)
		{
			Logger.error("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (LayoutHandlerException lhe)
		{
            Logger.error("Failed to retrieve the report layout list for category");
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}