//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using ReportExecutor = com.intellica.client.report.ReportExecutor;
// Has run report method
using ReportInfo = com.intellica.client.report.ReportInfo;
using SaveReportInfo = com.intellica.client.report.SaveReportInfo;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using Enums = com.intellica.client.common.Enums;
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using InteraConstants = com.intellica.client.common.InteraConstants;
using HashContainer = com.intellica.client.utils.HashContainer;
// Object used to pass parameters collection
using ClientException = com.intellica.client.exception.ClientException;
// Exception class
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 

//This class is used to publish a report.
//Required steps are :
//1) Create a userinfo Object of current logged in User.
//2) Set Report Id which is to be published. 
//3) Set system parameters needed to publish the report.
//4) Set user parameters if required for that report  
//5) Send publish request to the server.

public partial class ReportOperations
{
	public static void PublishReport()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
						
			//fill up the system parameter values
			//Report ID which is required to run
            System.String reportId = "2C01C803-D4F1-5737-FFE3-C16A3A8E3849"; //4B0B9D74-0A7D-8B3A-A7B0-F6177295BF6E
			
			//if (args.Length > 0)
			//{
			//	//get the ReportId from command-line
			//	reportId = args[0];
			//}
			
			//Instantiate a collection object for setting system parameters
			HashContainer hcSysParams = new HashContainer();
			
			
			// This will set Id of the report.
            hcSysParams.put("REPORT_ID", "2C01C803-D4F1-5737-FFE3-C16A3A8E3849"); // In database mode only reportId needed.don't prefix category id
			// This will set the output format for the report.report format can be PDF/XLS/HTML
			hcSysParams.put("REPORT_FORMAT", InteraConstants.ReportFormats.PDF);
			
			
			//Instantiate a collection object for setting user/business parameters
			HashContainer hcUserParams = new HashContainer();
			
			/*// fill up the user params if report contains any parameter
			hcUserParams.put("Country","Australia"); // Parameter Name as created in the report layout(IRL)	       
			hcUserParams.put("Role_ID","3818");*/
			//Instantiate Report Executor, Not Report Runner :-(
			ReportExecutor report = new ReportExecutor();
						
			ReportInfo repInfo = new ReportInfo(requestorUserInfo, hcSysParams, hcUserParams);
			
			SaveReportInfo saveReportInfo = new SaveReportInfo(reportId);
			
			saveReportInfo.setProperty(Enums.Batch.SysParamNames.SAVEFILENAME, "abcdefg");
			saveReportInfo.setProperty(Enums.Batch.SysParamNames.SAVEEXPIRYDATE, "");
			repInfo.SaveReportInfo = saveReportInfo;
			
			//Publishes a report by taking the values of system defined parameters and report 
			//parameters in HashContainer and publishes the Report.
			//This method generates the complete report, and then returns the control to 
			//the calling code. In this case, the calling code must catch the exceptions 
			//right at the calling place. 
			report.saveReport(repInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (ClientException ce)
		{
            Logger.debug("Error Message:" + ce.ErrorMessage);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	}
}