/* This Program Adds column ti the Intellicus Repository and also fetch data feature.
* User would require to use following Intellicus jar files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll
*/

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
/// 
using System;
using UserInfo = com.intellica.client.common.UserInfo;
using com.impetus.intera.reportobjects;
using com.impetus.interaj.globals;
//This class is to manipulate the report objects.
using BaseException = com.intellica.client.exception.BaseException;
// This class is the base class of all the application generated exceptions engine may throw.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using SQLEditor = com.impetus.intera.layout.sqleditor.SQLEditor;
//This class contains properties and parsing logic for the SQLEDITOR of the report. 
using Enums = com.intellica.client.common.Enums;
// Has Enums for the constants used
using ReportClient = com.intellica.client.init.ReportClient;
//The purpose of this class to initialize the ConfigManager object. 
using Filter = com.intellica.client.common.Filter;
//This class hold information about Filter applied in Adhoc Report Layout.
using LayoutManager = com.intellica.client.layout.LayoutManager;
//For all report layout operations client creates the object of this class
using InvalidResponseException = com.intellica.client.exception.InvalidResponseException;
using HashContainer = com.intellica.client.utils.HashContainer;
//This is a utility class which stores the value with a key.It is never case sensitive

//This Class adds column to the Intellicus Repository and fetches data into it.For this it is
//required to provide the SQL source.
public partial class ReportObjectMgr
{

    public static void AddColumnWithFetchData(System.String[] args)
	{
		QOUseCase();
	}
	
	public static void  QOUseCase()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			System.IO.Stream is_Renamed = new System.IO.BufferedStream(new System.IO.FileStream(@"E:\Intellicus Working\temp\IntellicusDotNetAPI\client\config\ReportClient.properties", System.IO.FileMode.Open, System.IO.FileAccess.Read)); 
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// SUPER ADMIN
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			System.String qoName = "QO334";
			
			QueryObject qoObj = (QueryObject) reportObjectManager.getReportObjectByName(Enums.IRO.TYPE.QUERY, qoName, requestorUserInfo);
			
			//The class contain all the information relate COLUMN Tag of Query Object 
			QueryObjectColumn qoc = qoObj.getColumn("ACCOUNT_OWNER_NAME");
			qoc.ToFetchData = true;
			FetchData fetchData = new FetchData();
			
			SourceSQL srcSQL = new SourceSQL();
			
			SQLEditor sqlEditor = new SQLEditor();
			sqlEditor.setSQL("select ACCOUNTS.* from ACCOUNTS");
			srcSQL.SqlEditor = sqlEditor;
			srcSQL.DisplayColumn = "ACCOUNT_OWNER_NAME";
			fetchData.FetchDataSrc = "SOURCESQL";
			fetchData.setSrcSQL(srcSQL);
			
			qoc.FetchData = fetchData;
			//save the query object in intellicus 
			System.String status = "";
			reportObjectManager.replaceReportObject(qoObj, requestorUserInfo);
			
			//if the status string contains error 
			if (status.ToLower().IndexOf("error") != - 1)
			{
				Logger.debug("operation status " + status);
				//throw an excpetion if required
			}
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
	public static void  filerUseCase()
	{
		try
		{
			//initialize report client 
			ReportClient.init();
			LayoutManager lm = new LayoutManager();
			// SUPER ADMIN
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			
			UserInfo userInfo = new UserInfo(userId, password, organization);
			Filter f = new Filter();
			f.setFilterField(Enums.Filters.SavedReportList.ISPUBLIC, null);
			f.setFilterField(Enums.Filters.SavedReportList.CATID, "99818F82-0161-BCEC-314E-730DCFB1B606");
			f.setFilterField(Enums.Filters.SavedReportList.REPORTID, null);
			f.setFilterField(Enums.Filters.SavedReportList.ORGID, organization);
			f.setFilterField(Enums.Filters.SavedReportList.USERID, "normaluser");
			
			System.Collections.ArrayList vectorSavedReport = lm.getSavedReportList(f, userInfo);
			System.Collections.IEnumerator itr = vectorSavedReport.GetEnumerator();
			com.intellica.client.reportutils.SavedReport svdReport = null;
			//UPGRADE_TODO: Method 'java.util.Iterator.hasNext' was converted to 'System.Collections.IEnumerator.MoveNext' which has a different behavior. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javautilIteratorhasNext'"
			while (itr.MoveNext())
			{
				//UPGRADE_TODO: Method 'java.util.Iterator.next' was converted to 'System.Collections.IEnumerator.Current' which has a different behavior. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javautilIteratornext'"
				svdReport = (com.intellica.client.reportutils.SavedReport) itr.Current;
			}
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}