/* This sample code is to add a new parameter Object in the Intellicus repository.
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll
*/

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using UserInfo = com.intellica.client.common.UserInfo;
using com.impetus.interaj.globals;
using ParameterObject = com.impetus.intera.reportobjects.ParameterObject;
using ReportObjectException = com.impetus.intera.reportobjects.ReportObjectException;
using ReportObjectManager = com.impetus.intera.reportobjects.ReportObjectManager;
//This class is used for Report Object related operations.
using ReportObject = com.impetus.intera.reportobjects.ReportObject;
//This class is super class of all the report objects 
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
using InputParam = com.intellica.client.reportutils.InputParam;
//in initializing the report Engine interface (REInterface). 
using Enums = com.intellica.client.common.Enums;
// Has Enums for the constants used

public partial class ReportObjectMgr
{
    public static void AddPOToCategory()
	{
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			System.IO.Stream is_Renamed = new System.IO.BufferedStream(new System.IO.FileStream(@"E:\Intellicus Working\temp\IntellicusDotNetAPI\client\config\ReportClient.properties", System.IO.FileMode.Open, System.IO.FileAccess.Read)); 
			//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			//This class contains method to get/replace/add/delete a parameter object(QO)
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			//To create the Object of Report Object class.
			//public static ReportObject createReportObject(String roType)
			ParameterObject poObj = (ParameterObject) ReportObject.createReportObject(Enums.IRO.TYPE.PARAMETER);
			//This will be used as Name of the Parameter Object. 	
			System.String poName = "param3";
			System.String poId = "param3";
			//To set the name of the parameter Object.	
			poObj.Name = poName;
			//To set the ID for parameter Object
			poObj.Id = poId;
			InputParam inputParam = new InputParam();
			inputParam.Name = poName;
			poObj.setInputParam(inputParam);
			//To set the category ID in which the parameter is desired to be created.
			poObj.CategoryId = "F6D1290E-B070-0509-42C7-B7FD3556910C";
			reportObjectManager.addReportObject(poObj, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (ReportObjectException roe)
		{
			Logger.debug("Error Message:" + roe.ErrorMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	} //End of the main.	
}