/* This sample code is to add a new Query Object in the Intellicus repository.
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll
*/

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using ReportObjectException = com.impetus.intera.reportobjects.ReportObjectException;
using ReportObjectManager = com.impetus.intera.reportobjects.ReportObjectManager;
//This class is used for Report Object related operations.
using ReportObject = com.impetus.intera.reportobjects.ReportObject;
//This class is super class of all the report objects 
using QueryObject = com.impetus.intera.reportobjects.QueryObject;
// This class contains all the details about the query object.
using QueryObjectColumn = com.impetus.intera.reportobjects.QueryObjectColumn;
//The class contain all the information relate COLUMN Tag of Query Object
using BaseException = com.intellica.client.exception.BaseException;
// This class is the base class of all the application generated exceptions engine may throw.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using SQLEditor = com.impetus.intera.layout.sqleditor.SQLEditor;
//This class contains properties and parsing logic for the SQLEDITOR of the report. 
using Enums = com.intellica.client.common.Enums;
// Has Enums for the constants used

public partial class ReportObjectMgr  
{
    public static void AddQOToCategory()
	{
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			System.IO.Stream is_Renamed = new System.IO.BufferedStream(new System.IO.FileStream(@"E:\Intellicus Working\temp\IntellicusDotNetAPI\client\config\ReportClient.properties", System.IO.FileMode.Open, System.IO.FileAccess.Read)); 
			//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			//This class contains method to get/replace/add/delete a Query object(QO)
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			//To create the Object of Report Object class.
			//public static ReportObject createReportObject(String roType)
			QueryObject qoObj = (QueryObject) ReportObject.createReportObject(Enums.IRO.TYPE.QUERY);
			
			//This will be used as Name of the Query Object. 	
			System.String qoName = "testQO";
			//To set the name of the Query Object.	
			qoObj.Name = qoName;
			//To set the ID for Query Object manually
			qoObj.Id = "testQO";
			//Set Category ID in order to create query object in a specific categroy.
			qoObj.CategoryId = "F6D1290E-B070-0509-42C7-B7FD3556910C";
			
			//To set caching true or false for the Query Object
			qoObj.Cached = true;
			//To set the description for the Query Object
			qoObj.Description = "This Query gives information related to the Countries.";
			//To set the Connection type for the Query Object.It may be Default Or Named. 
			qoObj.ConnectionType = "Default";
			//If Connection Type is Named then To set the Connection name for the Querry Object.
			qoObj.ConnectionName = "ReportDB";
			//Whether to set the Group caption or not
			qoObj.GroupCaption = true;
			//To set the source for the Query Object
			qoObj.Source = "SQL";
			//Whether to set the filter mandatory for any field or not
			qoObj.IsFilterMandatory = false;
			
			//Sql Query that is to be set
			System.String sqlQuery = "select COUNTRY.* from COUNTRY";
			//Create the SQLEditor Object.
			SQLEditor sqlEditor = qoObj.SqlEditor;
			//To set the SQL for fields in Query Object.
			//public void setSQL(String newQueryObjectSQL,boolean isEditDirty)
			sqlEditor.setSQL(sqlQuery, true);
			
			//Adding a new Column in the Query Object
			//To add the columns in Query Object.
			// QueryObjectColumn(String columnName,
			//                   String caption,
			//                   String width,
			//                   String dataType)
			QueryObjectColumn qoc1 = new QueryObjectColumn("COUNTRY_CD", "COUNTRY_CD", "", "");
			QueryObjectColumn qoc2 = new QueryObjectColumn("COUNTRY", "COUNTRY", "", "");
			QueryObjectColumn qoc3 = new QueryObjectColumn("FLAG", "FLAG", "", "");
			
			//Setting other Attributes for the above Column name "JOB"
			//To Set the Alignment for the Column
			qoc1.Alignment = 1; // Left Alignment: 0 , Right Alignment: 1
			//To set the Data Type 
			qoc1.DataType = "Number";
			//Whether to hide this column or not, True : For hidding the Column
			qoc1.Hidden = false;
			//To set the width
			qoc1.Width = "20";
			//To set this column in a group
			qoc1.GroupLabelCaption = "Job";
			//To set the Output Format
			qoc1.Format = "Number";
			//To set hyperlink for this column 
			System.String hyperLink = "DRILLDOWN:REPORT_ID=E85A9025-6AB9-4EDB-0DE3-E0533FAFAB04:ACTION_CODE=002:MENU_NAME=All Country  Sales:CATEGORY_ID=4F9245A7-D639-4F99-604D-F32641B77725:DSGN_MODE=ADHOC:~TARGET=0";
			//qoc1.setHyperlink(hyperLink);
			
			//Creting ArrayList that contains object of QueryObjectColumn as its elements 
			System.Collections.ArrayList ArrColumn = new System.Collections.ArrayList();
			//Adding the objects of QueryObjectColumn to the ArrayList
			ArrColumn.Add(qoc1);
			ArrColumn.Add(qoc2);
			ArrColumn.Add(qoc3);
			
			//To set the columns in the Query Object by passing the ArrayList as arguement.
			//public void setColumnDetails(java.util.ArrayList columnDetails)
			qoObj.ColumnDetails = ArrColumn;
			//To Add and Save the Query Object, use addReportObject() method of ReportObjectManager
			//addReportObject(com.impetus.intera.reportobjects.ReportObject reportObject,
			//                com.intellica.client.common.UserInfo userInfo)
			reportObjectManager.addReportObject(qoObj, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (ReportObjectException roe)
		{
			Logger.debug("Error Message:" + roe.ErrorMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	} //End of the main.	
}