/* This sample code is to delete the existing Query Object in the Intellicus repository.
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll
*/

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
/// 
using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using ReportObjectException = com.impetus.intera.reportobjects.ReportObjectException;
using ReportObjectManager = com.impetus.intera.reportobjects.ReportObjectManager;
//This class is used for Report Object related operations.
using QueryObject = com.impetus.intera.reportobjects.QueryObject;
// This class contains all the details about the query object.
using BaseException = com.intellica.client.exception.BaseException;
// This class is the base class of all the application generated exceptions engine may throw.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
using Enums = com.intellica.client.common.Enums;
// Has Enums for the constants used

public partial class ReportObjectMgr   
{
    public static void DeleteReportObject()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			System.IO.Stream is_Renamed = new System.IO.BufferedStream(new System.IO.FileStream(@"E:\Intellicus Working\temp\IntellicusDotNetAPI\client\config\ReportClient.properties", System.IO.FileMode.Open, System.IO.FileAccess.Read)); 
			//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			//This class contains method to get/replace/add/delete a Query object(QO)
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			//This will take the name of Query Object that is to be deleted.
			System.String qoName = "newqo1";
			
			//This is to Get java object of query object.
			//getReportObjectByName method returns report object type object and you would require
			// to type cast this object with java objet of Query Object class.
			QueryObject qoObj = (QueryObject) reportObjectManager.getReportObjectByName(Enums.IRO.TYPE.QUERY, qoName, requestorUserInfo);
			
			//This will be used to Delete the Query Object.
			//deleteReportObject(com.impetus.intera.reportobjects.ReportObject reportObject,
			//                   com.intellica.client.common.UserInfo userInfo)
			reportObjectManager.deleteReportObject(qoObj, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (ReportObjectException roe)
		{
			Logger.debug("Error Message:" + roe.ErrorMessage);
		}
		catch (System.Exception e)
		{
			
			Logger.error(e);
		}
	} //End of the main.	
}