//This API is used to get IP Address and Port of the Report Engine.
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface). 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using LayoutManager = com.intellica.client.layout.LayoutManager;
// for report layout management related operations

/// <summary> 
/// This class is used to get Report Engine's IP Address and Port number, i.e. set through any of the constructor or if not then returns the default value from ConfigManager class.
/// Method used to implement this returns String value.
/// </summary>
public partial class ReportServerproperty
{
	
	public static void  GetReportEnginePortAndIP()
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			// method used to get the IP Address of Report Engine 
			// Returns ReportEngine IP as a String value.
			System.String reportEngineIP = lm.ReportEngineIP;
			
			// method used to get the Port of Report Engine 
			// Returns report Engine Port as Integer value
			int reportEnginePort = lm.ReportEnginePort;
			
			Logger.debug("IP Address Of the ReportEngine : " + reportEngineIP);
			Logger.debug("Port Of the Report Engine : " + reportEnginePort);
		}
		catch (InterfaceInitException iie)
		{
			Logger.error("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}