// This program Creates a userinfo Object of current logged in User.
// Returns SMTP Server Value
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using ClientException = com.intellica.client.exception.ClientException;
//This class is used to create 
//generalized exception which may occure at
//any application level.It is not bounded with any use case. 
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
// Array list
using SecurityManager = com.intellica.client.security.SecurityManager;
// This is the controller class for all 
//Administration related operations

// This  class Creates a userinfo Object of current logged in User and Returns SMTP Server Value

public partial class ReportServerproperty 
{
    public static void GetReportServerProperty()
	{
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
            SecurityManager sMgr = SecurityManager.Instance;
			
			// This will return array list  of values of Reporrt Server properties.
			System.Collections.ArrayList arrList = sMgr.getReportServerPropDetails(requestorUserInfo);
			
			//Set the key for the server property.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			System.String key = "SMTP_SERVER"; // For getting value for Report Server property.
			
			//This will return value for the SMTP_SERVER specified as key.
			System.String value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SMTP_SERVER Value : " + value_Renamed);
			
			key = "LISTENER_PORT";
			
			//This will return value for the LISTENER_PORT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug(" LISTENER_PORT Value : " + value_Renamed);
			
			key = "DATABASE_CONNECTION_TIMEOUT";
			
			//This will return value for the DATABASE_CONNECTION_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("DATABASE_CONNECTION_TIMEOUT Value : " + value_Renamed);
			
			key = "SECURITY_FEATURES";
			
			//This will return value for the SECURITY_FEATURES specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SECURITY_FEATURES Value : " + value_Renamed);
			
			key = "AUDIT_LOG";
			
			//This will return value for the AUDIT_LOG specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("AUDIT_LOG Value : " + value_Renamed);
			
			key = "QUEUE_SIZE";
			//This will return value for the QUEUE_SIZE specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("QUEUE_SIZE Value : " + value_Renamed);
			
			
			key = "PAGE_CHUNKSIZE";
			//This will return value for the PAGE_CHUNKSIZE specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("PAGE_CHUNKSIZE Value : " + value_Renamed);
			
			key = "LOG_LEVEL";
			//This will return value for the LOG_LEVEL specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("LOG_LEVEL Value : " + value_Renamed);
			
			key = "OUTPUT_DIRECTORY";
			//This will return value for the OUTPUT_DIRECTORY specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("OUTPUT_DIRECTORY Value : " + value_Renamed);
			
			
			key = "XML_DATA_SOURCE_DIRECTORY";
			//This will return value for the XML_DATA_SOURCE_DIRECTORY specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("XML_DATA_SOURCE_DIRECTORY Value : " + value_Renamed);
			
			key = "TEMP";
			//This will return value for the TEMP specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("TEMP Value : " + value_Renamed);
			
			key = "LOG";
			//This will return value for the LOG specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("LOG Value : " + value_Renamed);
			
			key = "USER_THREADS";
			//This will return value for the USER_THREADS specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("USER_THREADS Value : " + value_Renamed);
			
			key = "CANCEL_THREADS";
			//This will return value for the CANCEL_THREADS specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CANCEL_THREADS Value : " + value_Renamed);
			
			key = "SERVICE_THREADS";
			//This will return value for the SERVICE_THREADS specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SERVICE_THREADS Value : " + value_Renamed);
			
			key = "FONT_DIRECTORY";
			//This will return value for the FONT_DIRECTORY specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("FONT_DIRECTORY Value : " + value_Renamed);
			
			key = "LEFT_MARGIN_OFFSET";
			//This will return value for the LEFT_MARGIN_OFFSET specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("LEFT_MARGIN_OFFSET Value : " + value_Renamed);
			
			key = "TOP_MARGIN_OFFSET";
			//This will return value for the TOP_MARGIN_OFFSET specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("TOP_MARGIN_OFFSET Value : " + value_Renamed);
			
			key = "SCALE_OFFSET";
			//This will return value for the SCALE_OFFSET specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SCALE_OFFSET Value : " + value_Renamed);
			
			key = "CLIENT_SESSION_TIMEOUT";
			//This will return value for the CLIENT_SESSION_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CLIENT_SESSION_TIMEOUT Value : " + value_Renamed);
			
			key = "REMOTE_SESSION_TIMEOUT";
			//This will return value for the REMOTE_SESSION_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("REMOTE_SESSION_TIMEOUT Value : " + value_Renamed);
			
			key = "RTF_FIELD_CONTROL_MAP";
			//This will return value for the RTF_FIELD_CONTROL_MAP specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("RTF_FIELD_CONTROL_MAP Value : " + value_Renamed);
			
			key = "DATA_SOURCE_FETCH_SIZE";
			//This will return value for the DATA_SOURCE_FETCH_SIZE specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("DATA_SOURCE_FETCH_SIZE Value : " + value_Renamed);
			
			
			key = "CSA_TIMEOUT";
			//This will return value for the CSA_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CSA_TIMEOUT Value : " + value_Renamed);
			
			key = "CACHE_PATH";
			//This will return value for the CACHE_PATH specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CACHE_PATH Value : " + value_Renamed);
			
			key = "AUDITLOG_PURGE_TIME";
			//This will return value for the AUDITLOG_PURGE_TIME specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("AUDITLOG_PURGE_TIME Value : " + value_Renamed);
			
			key = "CACHE_PURGE_TIME";
			//This will return value for the CACHE_PURGE_TIME specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CACHE_PURGE_TIME Value : " + value_Renamed);
			
			
			key = "AUTHORIZATION_CACHE_TIMEOUT";
			//This will return value for the AUTHORIZATION_CACHE_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("AUTHORIZATION_CACHE_TIMEOUT Value : " + value_Renamed);
			
			key = "REPOSITORY_CACHE_TIMEOUT";
			//This will return value for the REPOSITORY_CACHE_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("REPOSITORY_CACHE_TIMEOUT Value : " + value_Renamed);
			
			key = "REPOSITORY_CACHE_TIMEOUT";
			//This will return value for the REPOSITORY_CACHE_TIMEOUT specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("REPOSITORY_CACHE_TIMEOUT Value : " + value_Renamed);
			
			key = "SORT_AREA_SIZE";
			//This will return value for the SORT_AREA_SIZE specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SORT_AREA_SIZE Value : " + value_Renamed);
			
			key = "FILE_DATA_SOURCE_PATH";
			//This will return value for the server property specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("FILE_DATA_SOURCE_PATH Value : " + value_Renamed);
			
			key = "DATA_CACHING";
			//This will return value for the FILE_DATA_SOURCE_PATH specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("DATA_CACHING Value : " + value_Renamed);
			
			key = "CACHE_FILES_COMPRESSION";
			//This will return value for the CACHE_FILES_COMPRESSION specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("CACHE_FILES_COMPRESSION Value : " + value_Renamed);
			
			
			key = "SCHD_JOB_DISPATCH_QUEUE_SIZE";
			//This will return value for the SCHD_JOB_DISPATCH_QUEUE_SIZE specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("SCHD_JOB_DISPATCH_QUEUE_SIZE Value : " + value_Renamed);
			
			key = "HELPER_EXEC_THREADS";
			//This will return value for the HELPER_EXEC_THREADS specified as key.
			value_Renamed = sMgr.getReportServerPropValue(arrList, key, requestorUserInfo);
			Logger.debug("HELPER_EXEC_THREADS Value : " + value_Renamed);
		}
		catch (ClientException ce)
		{
            Logger.error("Unable to get the value from report server");
		}
		catch (ISecurityException ise)
		{
            Logger.error("The Organization with the given details was not found");
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}