/* This program 
* 1) Creates a userinfo Object of current logged in User.
* 2) Set SMTP Server Value
//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll
*/

/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>

using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
using ISecurityException = com.intellica.client.exception.ISecurityException;
//This exception occurs if connection can't be established with the engine 
//or if read or write operation cant be performed from or to the engine
//or If some error has occured while executing the request on the engine.
//or If the response xml obtained from server cannot be parsed 
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
// Array list
using SecurityManager = com.intellica.client.security.SecurityManager;
// This is the controller class for all Administration related operations
//A HashMap lets you look up values by exact key (always case-sensitive). 

//This class  Creates a userinfo Object of current logged in User and Set SMTP Server Value
public partial class ReportServerproperty  
{
    public static void SetReportServerProperty()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			SecurityManager sMgr = SecurityManager.Instance;
			
			System.Collections.Hashtable ServerPropHMap = new System.Collections.Hashtable();
			
			System.String key = "SMTP_SERVER";
			System.String value_Renamed = "192.168.100.20";
			// Set the key for the server property, SMTP_SERVER.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "DATABASE_CONNECTION_TIMEOUT";
			value_Renamed = "800";
			// Set the key for the server property, DATABASE_CONNECTION_TIMEOUT.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "SECURITY_FEATURES";
			value_Renamed = "enabled";
			// Set the key for the server property, SECURITY_FEATURES.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "QUEUE_SIZE";
			value_Renamed = "900";
			// Set the key for the server property, QUEUE_SIZE.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "LOG";
			value_Renamed = "../logs";
			// Set the key for the server property, LOG.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "PAGE_CHUNKSIZE";
			value_Renamed = "10";
			// Set the key for the server property, PAGE_CHUNKSIZE.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "LOG_LEVEL";
			value_Renamed = "INFO";
			// Set the key for the server property, LOG_LEVEL.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "USER_THREADS";
			value_Renamed = "5";
			// Set the key for the server property, USER_THREADS.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "SERVICE_THREADS";
			value_Renamed = "5";
			// Set the key for the server property, SERVICE_THREADS.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "CLIENT_SESSION_TIMEOUT";
			value_Renamed = "600";
			// Set the key for the server property, CLIENT_SESSION_TIMEOUT.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "AUDITLOG_PURGE_TIME";
			value_Renamed = "30";
			// Set the key for the server property, AUDITLOG_PURGE_TIME.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "WITHHOLD_PURGE_TILL_ARCHIVE";
			value_Renamed = "disable";
			// Set the key for the server property, WITHHOLD_PURGE_TILL_ARCHIVE.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "REPOSITORY_CACHE_TIMEOUT";
			value_Renamed = "15";
			// Set the key for the server property, REPOSITORY_CACHE_TIMEOUT.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			key = "EXIT_ON_ERROR";
			value_Renamed = "disable";
			// Set the key for the server property, EXIT_ON_ERROR.This key is the name of the property as specified in the
			// ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			ServerPropHMap[key] = value_Renamed;
			
			//public String saveReportServerProperties(java.util.HashMap reportServerPropMap,
			//                                            UserInfo userInfo)throws ISecurityException
			//@param: reportServerPropMap - : HashMap which keeps the property name as key and its its concerning value as the value.
			//@param: userInfo            - : The UserInfo object 
			
			sMgr.saveReportServerProperties(ServerPropHMap, requestorUserInfo);
		}
		catch (ISecurityException ise)
		{
            Logger.error("Unable to save the Report server property details");
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}