//This API is used to add a new role in the existing Organization.
//The User need to provide the Role ID i.e. to be added and the Organization ID of the existing Organization in 
//which the Role is to be added.
//This would require user to provide UserInfo to authorize for Roles related Activities.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using SecurityManager = com.intellica.client.security.SecurityManager;
//Controller class for all security related operations  
using RoleInfo = com.intellica.client.security.RoleInfo;
// Has information about a role in the application
using ISecurityException = com.intellica.client.exception.ISecurityException;
// Exception class for all security related operations.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface).import com.intellica.client.init.ReportClient; // Has Init Method

/*
*This class is used to Add a Role in to the Intellicus Repository
*/
public partial class RoleManagement 
{
	
    public static void AddRoleWithBlankSpaceInRoleName()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as Add role etc.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			
			System.String roleId = "Manager 5"; // Id of the role to be added having blank space in role name/id
			System.String orgId = "Org1"; // Id of the organization in which role to be added
			
			// Create a Security controller class object using its factory 
			// for user/role management related operations
			SecurityManager sMgr = SecurityManager.Instance;
			
			//Stores the information about a role in the application.
			//A role can have certain preveleges such as it can have Admin rights,Access Rights for reports or category. 
			//A user in the application can have 0 or more roles,and takes various preveleges from the roles. 
			RoleInfo roleInfo = new RoleInfo(roleId, orgId);
			
			//	Method to add a new role 
			//  Syntax : addRole (role to be added , requestor admin user)
			sMgr.addRole(roleInfo, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (ISecurityException e)
		{
			// Rootcause of the SecurityException sent by the report server
            Logger.error("Error from Server:" + e.ExtMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	} // End of main function
}