//This Java API is used to get the list of all Roles present in Intellicus Repository
//This would require user to provide UserInfo to authorize for Roles related Activities.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using SecurityManager = com.intellica.client.security.SecurityManager;
//Controller class for all security related operations  
using RoleInfo = com.intellica.client.security.RoleInfo;
// Has information about a role in the application
using ISecurityException = com.intellica.client.exception.ISecurityException;
// Exception class for all security related operations.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface).import com.intellica.client.init.ReportClient; // Has Init Method

/*
* This class is used to get list of all existing roles in the Intellicus Repository.
*/
public partial class RoleManagement  
{
	
    public static void GetRoleList()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as Add role etc.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String userId = "Admin";
			System.String password = "Admin";
			System.String organization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(userId, password, organization);
			
			// Create a Security controller class object using its factory 
			// for user/role management related operations
			SecurityManager sMgr = SecurityManager.Instance;
			
			
			// ArrayList containing roleInfo objects return from Repository
			System.Collections.ArrayList roleList = sMgr.getRoleList(requestorUserInfo);
			
			//Iterate Arraylist to display Id of all roles
			for (int i = 0; i < roleList.Count; i++)
			{
				//Stores the information about a role in the application.
				//A role can have certain preveleges such as it can have Admin rights,Access Rights for reports or category. 
				//A user in the application can have 0 or more roles,and takes various preveleges from the roles. 
				RoleInfo roleInfo = (RoleInfo) roleList[i];
                Logger.debug("RoleId:" + roleInfo.RoleId);
			}
		}
		catch (InterfaceInitException iie)
		{
			Logger.error("Could not connect to report server::" + iie.ErrorMessage);
			//	iie.printStackTrace();
		}
		catch (ISecurityException e)
		{
			// Rootcause of the SecurityException sent by the report server
            Logger.error("Error from Server:" + e.ExtMessage);
		}
		catch (System.Exception e)
		{
            Logger.error(e);
		}
	} // End of main function
}