// This program 
// 1) creates a new user with this given userId, 
// 2) Maps the new user with the same names App ID when authentication is done by call back method or host application.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
//UPGRADE_TODO: The type 'com.intellica.client.init.ReportClient' could not be found. If it was not included in the conversion, there may be compiler issues. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1262'"
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
//UPGRADE_TODO: The type 'com.intellica.client.common.UserInfo' could not be found. If it was not included in the conversion, there may be compiler issues. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1262'"
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
//UPGRADE_TODO: The type 'com.intellica.client.security.SecurityManager' could not be found. If it was not included in the conversion, there may be compiler issues. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1262'"
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has user management methods
//UPGRADE_TODO: The type 'com.intellica.client.exception.ISecurityException' could not be found. If it was not included in the conversion, there may be compiler issues. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1262'"
using ISecurityException = com.intellica.client.exception.ISecurityException;
// For exceptions during user management
//UPGRADE_TODO: The type 'com.intellica.client.exception.InterfaceInitException' could not be found. If it was not included in the conversion, there may be compiler issues. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1262'"
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface). 

//This class adds a new user to the existing organization with a given user id and also do mapping of application user to Intellicus user when
//authentication is done by call back authentication method or host application..
public partial class UserManagement 
{
    public static void AddUserWithBlankSpaceInUserName()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
			
			// Create a SecurityManager class object 
			// for getting the controller information for all Administration related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			// prepare new user info			
			System.String userId = "MNormal User"; // id having blank space in user id
			System.String password = "MNormal";
            System.String organization = "Org1";
			
			// Create a User Info Object for adding a new user
			UserInfo addUserInfo = new UserInfo(userId, password, organization);
			
			// set this user as Admin User for his organization.
			//addUserInfo.setAdmin(true);
			
			//Set User Password as Blank when authentication performed by Host application.
			//addUserInfo.setBlankPassword(true);
			
			//To Add new user.
			//Syntax: public void addUser(UserInfo newUserInfo,UserInfo userInfo)             
			//@param newUserInfo -  The new user or target user details 
			//@param userInfo    -  The current user details 
			sMgr.addUser(addUserInfo, requestorUserInfo);
						
			//  Map intellicus user to the host application	user
			//  map User (Aplplication user id string, 
			//                         user info of intellicus user to be mapped 
			//                                 , requestor admin user)
			//  assuming we are mapping chris1 to chris1
			//@param requestorUserInfo - The current user details who is providing access rights 
			//					         to the specified user.
			
			//@param addUserInfo - The user info of the user that is to be added.
			sMgr.mapAppIdToUser(userId, addUserInfo, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::" + iie.ExtMessage);
		}
		catch (ISecurityException ise)
		{
            Logger.error("Failed to add a new user::" + ise.ExtMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}