// This program 
// 1) delete user with this given userId,  
//The user would require to provide its identity i.e. user Info to authorize for managing Users.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has user management methods
using ISecurityException = com.intellica.client.exception.ISecurityException;
// For exceptions during user management
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any 
//error in initializing the report Engine interface (REInterface). 

//This class deletes the user with given user id.The requestor user who wants to delete any user required to have the rights to
//delete.

public partial class UserManagement
{
	
    public static void DeleteUser()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			System.IO.Stream is_Renamed = new System.IO.BufferedStream(new System.IO.FileStream(@"E:\Intellicus Working\temp\IntellicusDotNetAPI\client\config\ReportClient.properties", System.IO.FileMode.Open, System.IO.FileAccess.Read)); 
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
			
			
			// Create a Security controller class object using its factory 
			// for user management related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			
			// prepare new user info			
			System.String userId = "FinanaceUser";
			System.String orgId = "FinanceOrg"; //Organization Id in which user exists.
			// Prepare a Target user info bean object.
			//This will used to get user Information.
			//Syntax: public UserInfo getUserById(String userId,String orgId,
			//        UserInfo userInfo)
			
			UserInfo targetUserInfo = sMgr.getUserById(userId, orgId, requestorUserInfo);
			
			// Create a User Info Object for Deleting a existing user
			//Syntax : public void deleteUser(UserInfo targetUInfo,
			//         UserInfo userInfo) 
			
			//@param targetUInfo - The UserInfo object containing the changed details of user 
			//@param userInfo    - The current user details who is providing access rights 
			//					   to the specified user.
			
			sMgr.deleteUser(targetUserInfo, requestorUserInfo);
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::");
		}
		catch (ISecurityException ise)
		{
            Logger.error("Failed to add a new user::");
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}