// This program will return user info object for the given userid. 
//The user would require to provide its identity i.e. user Info to get authorized for performing 
//User Management related ativities.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using ReportClient = com.intellica.client.init.ReportClient;
//Has Init method.
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has mser management methods
using UserInfo = com.intellica.client.common.UserInfo;
using ISecurityException = com.intellica.client.exception.ISecurityException;
// Exception class for all security related operations.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error

// in initializing the report Engine interface (REInterface).import com.intellica.client.init.ReportClient; // Has Init Method

//This class will return the user for a given userId.And administrator can perform a lot 
//of manipulation on that organisation.
public partial class UserManagement 
{
    public static void GetUserById()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
			
			// Create a Security controller class object using its factory 
			// for user management related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			
			
			System.String orgId = "Org1"; //Organization Id in which user exists.
			
			System.String userId = "user6";
			//This will used to get user Information.
			//Syntax: public UserInfo getUserById(String userId,String orgId,
			//        UserInfo userInfo)
			UserInfo userInfoObj = sMgr.getUserById(userId, orgId, requestorUserInfo);
			//Retrieving information about the organisation in which the user exists,the description about 
			//the user ,the organisation id and the user id.
			System.Console.Out.Write("Organization   :    " + userInfoObj.Organization);
			System.Console.Out.Write("\nDescription   :   " + userInfoObj.Description);
			System.Console.Out.Write("\nOrganizationId :  " + userInfoObj.OrgID);
			System.Console.Out.Write("\nUserId   :        " + userInfoObj.UserId);
			System.Console.Out.Write("\n");
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (ISecurityException ise)
		{
            Logger.error("Error Message:" + ise.ExtMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	} // End of main function
}