// This program will map the host application user with Intellicus user
//The user would require to provide its identity i.e. user Info to authorize for User Mapping activities.

//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using UserInfo = com.intellica.client.common.UserInfo;
using ISecurityException = com.intellica.client.exception.ISecurityException;
// Exception class for all security related operations.
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface). 
using SecurityManager = com.intellica.client.security.SecurityManager;
// Has user management methods

//This class maps the Intellicus user to an application user.
public partial class UserManagement 
{
    public static void UserMapping()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			System.String userId = "user6";
			System.String userPassword = "";
			System.String userOrganisation = "Org1";
			UserInfo userInfo = new UserInfo(userId, userPassword, userOrganisation);
			UserInfo adminUserInfo = new UserInfo(adminId, adminPassword, adminOrganization);
			
			// Create a Security controller class object using its factory 
			// for user management related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager Instance
			SecurityManager sMgr = SecurityManager.Instance;
			System.String newUserId = "newUser";
			
			//  Map intellicus user to the host application	user
			//  map User (Aplplication user id string, 
			//                         user info of intellicus user to be mapped 
			//                                 , requestor admin user)
			//  assuming we are mapping chris1 to chris1
			//@param requestorUserInfo - The current user details who is providing access rights 
			//					         to the specified user.
			
			//@param addUserInfo - The user info of the user that is to be added.
			sMgr.mapAppIdToUser(newUserId, userInfo, adminUserInfo);
		}
		catch (InterfaceInitException iie)
		{
			Logger.debug("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (ISecurityException ise)
		{
            Logger.error("::Failed to Map user::");
	
		}
		catch (System.Exception e)
		{
            Logger.error("Exception caught");
			Logger.error(e);
		}
	} // End of main program
}