//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using UserInfo = com.intellica.client.common.UserInfo;
// Object used to pass in run report
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface).
using PersonalizationHandlerException = com.intellica.client.exception.PersonalizationHandlerException;
//This Exception class is 
//used for all Personalization use cases.
using ReportClient = com.intellica.client.init.ReportClient;
// Has Init Method
using Preferences = com.intellica.client.personalization.Preferences;
//Class contains the preferences of the user
using PersonalizationManager = com.intellica.client.personalization.PersonalizationManager;
//This class used for User Prefernces and 
//Dashboard related settings. It acts as the
//manager for all the classes in this package. 

/*
* This class is used to get the Default User Preferences set by the User
*/
public partial class UserPreferences
{

    public static void GetUserPreferences()
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			//Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as Add role etc.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo requestorUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
			
			PersonalizationManager pm = new PersonalizationManager();
			//Class contains the preferences of the user. The user preferences include 
			//Preferred Language of the user. 
			//Default Theme of the user. 
			//Default deleivery location for the reports of the user. 
			//Default report format for the user. 
			//Default email address of the user. 
			//Whether to show recent reports for the user. 
			//Whether to show reports published by the user. 
			//Whether to show the inbox to user. 
			//Default stylesheet of the user. 
			Preferences userPref = null;
			//userPref.setOwnerAppId("Admin");
			userPref = pm.getUserPreferences(requestorUserInfo);
			
			//Returns the defaultConnection
			
			System.String defaultCon = userPref.DefaultConnection;
			
			//Method returns the user's preferred default portal theme 
			System.String portalTheme = userPref.DefaultPortalTheme;
			
			//Method returns default stylesheet of the user
			System.String defaultStylesheet = userPref.DefaultStylesheet;
			
			//Method returns the user's preferred deliver location
			System.String deliveryLocation = userPref.DeliveryLocation;
			
			//Method returns the user's preferred report format
			System.String defaultFormat = userPref.Format;
			
			//Method returns the user's preferred language
			System.String prefLanguage = userPref.PrefLanguage;
			
			//Method returns the number of recent reports to be shown
			int reportCount = userPref.ReportCount;
			
			//Method returns the Boolean value whether to show the inbox or not
			System.Boolean showInbox = userPref.ShowInbox;
			
			//This Method returns default template name used for all reports
			System.String templateName = userPref.TemplateName;
			
			// Method returns the Boolean value whether to show the recent reports or not
			System.Boolean showRecentReports = userPref.ShowRecentReports;
			
			//Method returns the working folder set in the user preferences.
			System.String workingFolder = userPref.WorkingFolder;
			
			Logger.debug("Default Connection  :  " + defaultCon);
			Logger.debug("Default Portal Theme  :  " + portalTheme);
			Logger.debug("Default Stylesheet  :  " + defaultStylesheet);
			Logger.debug("Delivery Location  :  " + deliveryLocation);
			Logger.debug("Default Format  :  " + defaultFormat);
			Logger.debug("Default Preferred Language  :  " + prefLanguage);
			Logger.debug("Report Count  :  " + reportCount);
			//UPGRADE_TODO: The equivalent in .NET for method 'Boolean.toString' may return a different value. "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1043'"
			Logger.debug("Show Inbox  :  " + showInbox);
			Logger.debug("Template Name  :  " + templateName);
			Logger.debug("Show Recent Reports  :  " + showRecentReports);
			Logger.debug("Gets the Working Folder :  " + workingFolder);
		}
		catch (InterfaceInitException iie)
		{
            Logger.error("Could not connect to report server::" + iie.ErrorMessage);
		}
		catch (PersonalizationHandlerException phe)
		{
            Logger.error("Error Message" + phe.ExtMessage);
		}
		catch (System.Exception e)
		{
			Logger.error(e);
		}
	}
}