//User would require to use following Intellicus dll files for using Intellicus APIs:
//1) Intellicus.core.dll
//2) log4net.dll
//3) Intellicus.XercesUtilities.dll


/// <summary> 
/// DISCLAIMER OF WARRANTY
/// This source code is provided "as is" and without warranties as to performance or merchantability. 
/// This source code is provided without any express or implied warranties whatsoever
/// </summary>
using System;
using com.impetus.interaj.globals;
using InteraConstants = com.intellica.client.common.InteraConstants;
using UserInfo = com.intellica.client.common.UserInfo;
using InterfaceInitException = com.intellica.client.exception.InterfaceInitException;
using PersonalizationHandlerException = com.intellica.client.exception.PersonalizationHandlerException;
using ReportClient = com.intellica.client.init.ReportClient;
using PersonalizationManager = com.intellica.client.personalization.PersonalizationManager;
using Preferences = com.intellica.client.personalization.Preferences;

/*This Class is to set the Preferences for a particular organization by the Admin.
* */
public partial class UserPreferences 
{
    public static void OrgPreferenceSetByAdmin()
	{
		
		try
		{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
            System.IO.Stream is_Renamed = new System.IO.FileStream("<path of ReportClient.Properties file>", System.IO.FileMode.Open, System.IO.FileAccess.Read);
			//with the absolute path of ReportClient.properties.
			ReportClient.init(is_Renamed);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(String userId,String password,String orgId)constructor for creating UserInfo instance 
			//@param userId   - : Id of the User Logged-In.
			//@param password - : Password of the User Logged-In.
			//@param orgId    - : Organization Id from which User Logged-In.
			System.String adminUserId = "Admin";
			System.String adminPassword = "Admin";
			System.String adminOrganization = "Intellica";
			UserInfo adminUserInfo = new UserInfo(adminUserId, adminPassword, adminOrganization);
			
			//The organization id for which you want to set preferences.
			System.String organizationId = "Org1";
			
			
			PersonalizationManager pManager = new PersonalizationManager();
			//Variable for keeping details of user prefs
			Preferences userPref = new Preferences();
			// if userpref not null get user preference details to populate the user preferences in html
			if (userPref != null)
			{
				/* public void setDefaultPortalTheme(String defaultPortalTheme)
				* @Parameters:defaultPortalTheme - The string containing the user's 
				* preferred default-portal-theme
				* Set the default theme for the user*/
				userPref.DefaultPortalTheme = "Default";
				/*public void setPrefLanguage(String prefLanguage)
				* @Parameter:prefLanguage - The string containing the user's preferred language
				*  Set the default Language for the user*/
				userPref.PrefLanguage = "hi_IN";
				/*public void setTimeZone(String timeZone)
				* @Parameters:prefTimeZone -String Time zone
				* Set the default TimeZone for the user*/
				userPref.TimeZone = "US/Samoa";
				/*public void setFormat(String format)
				* @parameters:format - The string containing the report format
				* Set the Report  Format for the user*/
				userPref.Format = InteraConstants.ReportFormats.PDF;
				/*public void setTemplateName(String templateName)
				* @parameters:templateName - String Name of template
				* Set adhoc template name*/
				userPref.TemplateName = "Beach";
				/*public void setReportCount(int reportCount)
				* @Parameters:reportCount - The number of report recent reports to be shown.
				* Set the default value of Report Count for the user*/
				userPref.ReportCount = 8;
				/*public void setOwnerOrgId(String ownerOrgId)
				* Method sets the ownerOrgId attribute for the report.
				* Parameters:ownerOrgId - : Id of the organization for which 
				* the preferences is to be set.
				*/
				userPref.OwnerOrgId = organizationId;
				//Set the default Working Folder for the user
				//public void setWorkingFolder(String workingFolder)
				/*Method sets preferred/Working Folder of the user. 
				Parameters:
				workingFolder - - user's preferred/working Folder(The category Id is required to be set here)*/
                userPref.WorkingFolder = "E30D6AB6-AB4E-D890-7200-276F5588C3D9"; //category Id
				/* public void setDefaultConnection(String defaultConnection)
				* @Parameters:defaultConnection - The defaultConnection to set.
				* set the default Connection set by the user for Organization Preferences*/
				userPref.DefaultConnection = "Default";
				/*public void setType(String type)
				* @Parameters:Parameters:ownerAppId - : AppId who own the report.
				*Method sets the ownerAppId attribute for the report. 
				* */
				userPref.Type = "ORG";
				/*public Preferences updateUserPreferences(Preferences userPref,
				*                           UserInfo userInfo)
				*                     throws PersonalizationHandlerException  
				*   Parameters:userPref - The user preferences prefernces details
				*	userInfo - userInfo object for authorization. 
				*	Returns:Preferences 
				*	Throws: PersonalizationHandlerException   
				*	Method update the user preferences to the repository.
				**/
				pManager.updateUserPreferences(userPref, adminUserInfo);
			}
		}
		catch (InterfaceInitException iie)
		{
		}
		catch (PersonalizationHandlerException phe)
		{
		}
		catch (System.IO.IOException ioe)
		{
		}
	}
}